Index: pgadmin/include/frm/frmStatus.h
===================================================================
--- pgadmin/include/frm/frmStatus.h	(révision 8034)
+++ pgadmin/include/frm/frmStatus.h	(copie de travail)
@@ -47,6 +47,7 @@
     MNU_TERMINATE,
     MNU_COMMIT,
     MNU_ROLLBACK,
+	MNU_COPY_QUERY,
     TIMER_REFRESHUI_ID,
     TIMER_STATUS_ID,
     TIMER_LOCKS_ID,
@@ -138,6 +139,7 @@
     void OnExit(wxCommandEvent& event);
     
     void OnCopy(wxCommandEvent& ev);
+    void OnCopyQuery(wxCommandEvent& ev);
 
     void OnToggleStatusPane(wxCommandEvent& event);
     void OnToggleLockPane(wxCommandEvent& event);
Index: pgadmin/frm/frmStatus.cpp
===================================================================
--- pgadmin/frm/frmStatus.cpp	(révision 8034)
+++ pgadmin/frm/frmStatus.cpp	(copie de travail)
@@ -26,6 +26,7 @@
 #include "frm/frmStatus.h"
 #include "frm/frmHint.h"
 #include "frm/frmMain.h"
+#include "frm/frmQuery.h"
 #include "utils/pgfeatures.h"
 #include "schema/pgServer.h"
 #include "ctl/ctlMenuToolbar.h"
@@ -44,6 +45,7 @@
     EVT_MENU(MNU_EXIT,                               frmStatus::OnExit)
     
     EVT_MENU(MNU_COPY,                               frmStatus::OnCopy)
+    EVT_MENU(MNU_COPY_QUERY,                               frmStatus::OnCopyQuery)
 
     EVT_MENU(MNU_HELP,                               frmStatus::OnHelp)
     EVT_MENU(MNU_STATUSPAGE,                        frmStatus::OnToggleStatusPane)
@@ -218,6 +220,7 @@
     toolBar->AddTool(MNU_REFRESH, _("Refresh"), wxBitmap(readdata_xpm), _("Refresh"), wxITEM_NORMAL);
     toolBar->AddSeparator();
     toolBar->AddTool(MNU_COPY, _("Copy"), wxBitmap(clip_copy_xpm), _("Copy selected text to clipboard"), wxITEM_NORMAL);
+    toolBar->AddTool(MNU_COPY_QUERY, _("Open query tool"), wxBitmap(clip_copy_xpm), _("Open the query tool with the selected query"), wxITEM_NORMAL);
     toolBar->AddSeparator();
     toolBar->AddTool(MNU_CANCEL, _("Cancel"), wxBitmap(query_cancel_xpm), _("Cancel query"), wxITEM_NORMAL);
     toolBar->AddTool(MNU_TERMINATE, _("Terminate"), wxBitmap(terminate_backend_xpm), _("Terminate backend"), wxITEM_NORMAL);
@@ -702,6 +705,42 @@
 }
 
 
+void frmStatus::OnCopyQuery(wxCommandEvent& ev)
+{
+    ctlListView *list;
+    int row, col;
+    wxString text = wxT("");
+    wxString dbname = wxT("");
+		
+    // Only the status list shows the query
+    list = statusList;
+
+    // Get the database
+    row = list->GetFirstSelected();
+    col = 1;
+    dbname.Append(list->GetText(row, col));
+    
+    // Get the actual query
+    row = list->GetFirstSelected();
+    col = list->GetColumnCount() - 1;
+    text.Append(list->GetText(row, col) + wxT("\t"));
+    
+    // If we have some real query, launch the query tool
+    if (text.Length() > 0 && dbname.Length() > 0)
+    {
+        //pgDatabase *db=obj->GetDatabase();
+        pgConn *conn = new pgConn(connection->GetHostAddress(), dbname,
+          connection->GetUser(), connection->GetPassword(),
+          connection->GetPort(), connection->GetSslMode(), connection->GetDbOid());
+        if (conn)
+        {
+            frmQuery *fq = new frmQuery(mainForm, wxEmptyString, conn, text);
+            fq->Go();
+        }
+    }
+}
+
+
 void frmStatus::OnPaneClose(wxAuiManagerEvent& evt)
 {
     if (evt.pane->name == wxT("Activity"))
@@ -2285,6 +2324,7 @@
     btnRotateLog->Enable(false);
     
     editMenu->Enable(MNU_COPY, statusList->GetFirstSelected()>=0);
+    toolBar->EnableTool(MNU_COPY_QUERY, statusList->GetFirstSelected()>=0);
 }
 
 
@@ -2319,6 +2359,7 @@
     btnRotateLog->Enable(false);
     
     editMenu->Enable(MNU_COPY, lockList->GetFirstSelected()>=0);
+    toolBar->EnableTool(MNU_COPY_QUERY, false);
 }
 
 
@@ -2349,6 +2390,7 @@
     btnRotateLog->Enable(false);
     
     editMenu->Enable(MNU_COPY, xactList->GetFirstSelected()>=0);
+    toolBar->EnableTool(MNU_COPY_QUERY, false);
 }
 
 
@@ -2376,6 +2418,7 @@
     }
     
     editMenu->Enable(MNU_COPY, logList->GetFirstSelected()>=0);
+    toolBar->EnableTool(MNU_COPY_QUERY, false);
 }
 
 
